/****************************
CrushFTP GUI Panel custom js
*****************************/
/* Do not change these lines */
var panelTunnels = {};
panelTunnels.localization = {};
/****************************/

// Panel details
var panelName = "Tunnels";
var _panel = $("#pnl" + panelName);

// Localizations
panelTunnels.localization = {
	headerText : " ",
	pnlDescText : "Tunnels allow for specific access to services on your network ",
	btnAddText : "Add",
	btnCopyText : "Copy",
	btnRemoveText : "Remove",
	lblHttpsTunnelText : "HTTP(S) Tunnel",
	lblSSHPortForwardingText : "SSH Port Forwarding (Tunnel)",
	lblConfigTabText : " Config ",
	lblTunnelNameText : "Tunnel Name :",
	lblAutoStartText : " Auto Start",
	lblUserConfigurableText : "User Configurable",
	lblServerTabText : " Server ",
	lblDestinationHostText : "Destination Host :",
	lblDestinationPortText : "Destination Port :",
	lblClientTabText : " Client ",
	lblLocalClientIPText : "Local Client IP :",
	lblLocalClientPortText : "Local Client Port :",
	lblReverseText : " Reverse?",
	lblTweaksTabText : "Tweaks (advanced settings)",
	lblStableSecondsText : "Stable Seconds :",
	lblChannelRampUpText : "Channel Ramp Up :",
	lblSpeedThresholdText : "Speed Threshold Percentage :",
	lblMinFastSpeedText : "Min Fast Speed :",
	lblMinSlowSpeedText : "Min Slow Speed :",
	lblAckTimeoutText : "Ack Timeout :",
	lblSendBufferText : "Send Buffer (MB) :",
	lblConnectBtnText : "Connect Button's Text : &nbsp;&nbsp;&nbsp;",
	lblInChannelsText : "In Channels :&nbsp;&nbsp;&nbsp;",
	lblDisconnectBtnText : "Disconnect Button's Text :",
	lblOutChannelsText : "Out Channels :",
	lblRunAfterConnectingText : " Run after connecting: ",
	lblRunBeforeDisconnectingText : " Run before disconnecting: ",
	btnResetText : "Reset All Prefs to Default",
	btnCancelText : "Cancel",
	btnOKText : "Ok"
};

// Assign localizations
localizations.panels[panelName] = $.extend(panelTunnels.localization, localizations.panels[panelName]);

// Interface methods
panelTunnels.init = function(){
	applyLocalizations(panelName, localizations.panels);
	setPageTitle(panelTunnels.localization.Header, true);
	panelTunnels.bindData();
	panelTunnels.bindEvents();
}

panelTunnels.bindData = function()
{
	var prefs = $(document).data("GUIXMLPrefs");
	bindValuesFromXML(_panel, prefs);
	if(prefs["tunnels"])
	{
		var tunnels = prefs["tunnels"];
		if(tunnels.length>0)
		{
			tunnels = tunnels[0]["tunnels_subitem"];
			if(tunnels && tunnels.length>0)
			{
				var nameList = $("#tunnels", _panel);
				for(var i=0;i<tunnels.length;i++)
				{
					var curItem = tunnels[i];
					if(curItem)
					{
						var name = getTextValueFromXMLNode(curItem.name, "");
						var newControl = $("<li class='ui-widget-content' name='"+name+"'>"+name+"</li>");
						nameList.append(newControl);
						newControl.data("controlData", curItem);
					}
				}
			}
		}
	}
}

panelTunnels.bindEvents = function()
{
	var tunnels = $("#tunnels", _panel);
	tunnels.selectable({
		selected: function(event, ui) {
			var selected = $(ui.selected);
			selected.parent().find(".ui-widget-header").removeClass("ui-widget-header");
			selected.addClass("ui-widget-header");
			panelTunnels.bindFormDetails(selected);
			return false;
		}
	});

	$("a#addTunnel", _panel).click(function(){
		common.UI.addItem($("#tunnels", _panel)
						, $("<li class='ui-widget-content'>New Tunnel</li>")
						, {
							bindIp:[{text:"127.0.0.1"}],
							localPort:[{text:"55555"}],
							channelsOutAuto:[{text:"false"}],
							destPort:[{text:"55580"}],
							chunked:[{text:"true"}],
							run:[{text:"true"}],
							tunnelType:[{text:"HTTP"}],
							runAfterConnect:[{text:""}],
							buttonConnect:[{text:"Connect"}],
							channelsOut:[{text:"1"}],
							id:[{text:generateRandomCode(4)}],
							runBeforeDisconnect:[{text:""}],
							name:[{text:"New Tunnel"}],
							channelsInAuto:[{text:"false"}],
							buttonDisconnect:[{text:"Disconnect"}],
							channelsIn:[{text:"1"}],
							configurable:[{text:"false"}],
							destIp:[{text:"127.0.0.1"}],
							channelsOutMax:[{text:"1"}],
							channelsInMax:[{text:"1"}],
							reverse:[{text:"false"}],
							ram:[{text:"false"}],
							stableSeconds:[{text:"5"}],
							channelRampUp:[{text:"1"}],
							speedThreshold:[{text:"60"}],
							minFastSpeed:[{text:"100"}],
							minSlowSpeed:[{text:"50"}],
							ackTimeout:[{text:"30"}],
							sendBuffer:[{text:"1"}]
						}
						, panelTunnels.bindFormDetails);
		itemsChanged(true);
		return false;
	});

	$("a#copyTunnel", _panel).click(function(){
		common.UI.copyItem($("#tunnels", _panel).find("li.ui-selected"), panelTunnels.bindFormDetails);
		itemsChanged(true);
		return false;
	});

	$("a#removeTunnel", _panel).click(function(){
		common.UI.removeItem($("#tunnels", _panel), panelTunnels.bindFormDetails);
		itemsChanged(true);
		return false;
	});

	var formDetailsPanel  = $("#formDetailsPanel", _panel);
	formDetailsPanel.find("input, select, textarea").bind("change", function(){
		var item = tunnels.find("li.ui-selected");
		if(!item || item.length==0)return;
		var data = item.data("controlData");
		if(data)
		{
			if($(this).attr("name") == "tunnelType")
			{
				panelTunnels.showHideHTTPOptions();
				data["tunnelType"] = [{text: $(this).attr("id").replace("tunnelType_","")}];
			}
			else
			{
				var isBool = $(this).attr("type") == "radio" || $(this).attr("type") == "checkbox";
				data[$(this).attr("id")] = [{text: isBool ? $(this).is(":checked").toString() : $(this).val()}];
				if($(this).attr("id") == "name")
				{
					item.text($(this).val());
				}
			}
		}
		item.data("controlData", data);
	});

	formDetailsPanel.find("input[type='text'], textarea").bind("textchange", function(){
		var item = tunnels.find("li.ui-selected");
		if(!item || item.length==0)return;
		var data = item.data("controlData");
		if(data)
		{
			var isBool = $(this).attr("type") == "radio" || $(this).attr("type") == "checkbox";
			data[$(this).attr("id")] = [{text: isBool ? $(this).is(":checked").toString() : $(this).val()}];
			if($(this).attr("id") == "name")
			{
				item.text($(this).val());
			}
		}
		item.data("controlData", data);
	});
}

panelTunnels.showHideHTTPOptions = function()
{
	var actDiv = $("#forHTTPTunnelOnly", _panel);
	var flag = $("#tunnelType_SSH", _panel).is(":checked");
	if(flag)
	{
		actDiv.clearForm().hide();
		actDiv.find("input, select").trigger("change");
	}
	else
	{
		var selected = $("#tunnels", _panel).find("li.ui-widget-header");
		actDiv.clearForm().show();
		if(selected && selected.length>0)
		{
			panelTunnels.bindFormDetails(selected, actDiv);
			actDiv.find("input, select").trigger("change");
		}
	}
}

panelTunnels.bindFormDetails = function(tunnelList, panel)
{
	if(!tunnelList)
	{
		$("#formDetailsPanel", _panel).hide();
		return;
	}
	var controlData = $(tunnelList).data("controlData");
	var formDetailsPanel = panel || $("#formDetailsPanel", _panel).show();
	bindValuesFromXML(formDetailsPanel, controlData);
	if(!panel)
	{
		var actDiv = $("#forHTTPTunnelOnly", _panel).show();
		checkUnchekInput($("#tunnelType_" + getTextValueFromXMLNode(controlData.tunnelType, ""), _panel), true);
		var flag = $("#tunnelType_SSH", _panel).is(":checked");
		if(flag)
		{
			actDiv.clearForm().hide();
		}
	}
	return;
}

panelTunnels.saveContent = function()
{
	if(placeHolder.data("hasChanged"))
	{
		common.UI.showIndicator(false, false, "Please wait..");
		var xmlString = [];
		var folderList = $("#Tunnels", _panel).find("li");
		if(folderList.length>0)
		{
			xmlString.push("<tunnels type=\"vector\">");
			folderList.each(function(){
				xmlString.push("<tunnels_subitem type=\"properties\">");
				var controlData = $(this).data("controlData");
				for(var item in controlData)
				{
					if(controlData[item].length)
					{
						if(controlData[item][0].text)
						{
							xmlString.push("<"+item+">"+common.methods.htmlEncode(controlData[item][0].text)+"</"+item+">");
						}
					}
				}
				xmlString.push("</tunnels_subitem>");
			});
			xmlString.push("</tunnels>");
		}
		var formSubItem = xmlString.join("\n");
		var action = xmlString.length>0 ? "reset" : "remove";
		common.data.setXMLPrefs("server_settings/tunnels/0"
			, "vector"
			, action
			, formSubItem
			, function(data){
				data = $.xml2json(data, true);
				if(data.response_status && getTextValueFromXMLNode(data.response_status) && getTextValueFromXMLNode(data.response_status) == "OK")
				{
					xmlString = [];
					xmlString.push('<server_prefs type="properties">');
					xmlString.push("<tunnel_ram_cache>"+common.methods.htmlEncode($("#tunnel_ram_cache", _panel).val())+"</tunnel_ram_cache>");
					xmlString.push("</server_prefs>");
					var formSubItem = xmlString.join("\n");
					var action = xmlString.length>0 ? "reset" : "remove";
					common.data.setXMLPrefs("server_settings/server_prefs/"
						, "properties"
						, action
						, formSubItem
						, function(data){
							data = $.xml2json(data, true);
							if(data.response_status && getTextValueFromXMLNode(data.response_status) && getTextValueFromXMLNode(data.response_status) == "OK")
							{
								common.data.updateLocalPrefs(function(){
									common.UI.hideIndicator();
									growl("Data saved", "Your changes are saved", false, 5000);
									placeHolder.removeData("hasChanged");
								});
							}
							else
							{
								growl("Error while saving", "Your changes are not saved", true);
							}
						}
					);
				}
				else
				{
					growl("Error while saving", "Your changes are not saved", true);
				}
			}
		);
	}
	else
	{
		growl("No changes made", "", false, 3000);
	}
}