/****************************
CrushFTP GUI Panel custom js
*****************************/
/* Do not change these lines */
var panelServerInfo = {};
panelServerInfo.localization = {};
/****************************/

// Panel details
panelServerInfo.panelName = "ServerInfo";
panelServerInfo._panel = $("#pnl" + panelServerInfo.panelName);
panelServerInfo.serverItemContextMenu = $("#serverItemContextMenu", panelServerInfo._panel);

// Localizations
panelServerInfo.localization = {
};

// Assign localizations
localizations.panels[panelServerInfo.panelName] = $.extend(panelServerInfo.localization, localizations.panels[panelServerInfo.panelName]);

// Interface methods
panelServerInfo.init = function(){
	applyLocalizations(panelServerInfo.panelName, localizations.panels);
	panelServerInfo.bindEvents();
	$("#lstServers", panelServerInfo._panel).parent().resizable({minHeight:40, handles: 's' });
}

panelServerInfo.status = {
	logLiveUpdate : function()
	{
		return $("#server_log_live_update", panelServerInfo._panel).is(":checked") || $("#server_log", panelServerInfo._panel).text() == "";
	},
	logScrollWithActivity : function()
	{
		return $("#server_log_scroll_with_activity", panelServerInfo._panel).is(":checked");
	}
};

// Bind data from provided JSON to panel's fields
panelServerInfo.bindData  = {
	serverList : function(data, elem){
		data = data || adminPanel.storage("serverInfo");
		if(!data)
		{
			return;
		}
		elem = elem || $("#lstServers", panelServerInfo._panel);
		var selectedIndex = elem.find("li.ui-widget-header").index();
		if(elem && elem.length>0)
		{
			adminPanel.UI.multiOptionControlDataBind(data
				, "server_list"
				, elem
				, function(curItem){
					var display = unescape(curItem.display);
					if(display && display != "undefined")
					{
						if(elem.find("li[display='"+display+"']").length==0)
						{
							return $("<li class='ui-widget-content' running='"+curItem.running+"' display='"+display+"'>"+ display +"</li>");
						}
						else
							return false;
					}
					else
					{
						return false;
					}
				}
			);

			if(selectedIndex>=0)
			{
				selectedIndex += 1;
				elem.find("li.ui-widget-header").removeClass("ui-widget-header");
				elem.find("li:nth-child("+selectedIndex+")").addClass("ui-widget-header");
			}

			elem.find("li").contextMenu({
				topPadding : 110,
				leftPadding : 20,
				addClassSP : true,
				menu: 'serverItemContextMenu'
			}, function (action, el, pos, command) {
				panelServerInfo.adminAction(action);
				return false;
			}).click(function (evt) {
				evt.stopPropagation();
				evt.preventDefault();
				$(this).trigger("mousedown").trigger("mouseup");
				return false;
			}).bind("onBeforeContextMenu", function(){
				var running = $(this).attr("running");
				panelServerInfo.serverItemContextMenu.find(".ui-state-disabled").removeClass("ui-state-disabled");
				if(running == "true")
				{
					panelServerInfo.serverItemContextMenu.find(".start").addClass("ui-state-disabled");
				}
				else
				{
					panelServerInfo.serverItemContextMenu.find(".stop, .restart").addClass("ui-state-disabled");
				}
			});
		}
	},
	serverInfo : function(data, elem){
		data = data || adminPanel.storage("serverInfo");
		if(!data)
		{
			return;
		}
		elem = elem || $("#serverInfoTab", panelServerInfo._panel);
		if(elem && elem.length>0)
		{
			adminPanel.data.bindValuesFromJson(elem, data);
		}
		elem.find(".formatData, .hideZero").each(function(){
			var val = $(this).text();
			if($(this).hasClass("hideZero"))
			{
				val = adminPanel.methods.hideZero(val);
				$(this).text(val);
			}
			if($(this).hasClass("formatData"))
			{
				if(val && adminPanel.methods.isNumeric(val))
				{
					if($(this).hasClass("inKBs"))
					{
						val = parseFloat(val) * 1024;
					}
					$(this).text(adminPanel.methods.formatBytes(val));
					if($(this).hasClass("speedInSecond"))
					{
						$(this).text($(this).text() + " /sec");
					}
				}
			}
		});
	},
	serverLog : function(data, scroll, elem)
	{
		if(!data)
		{
			return;
		}
		elem = elem || $("#server_log", panelServerInfo._panel);
		if(elem && elem.length>0)
		{
			elem.text(data);
			var now = new Date();
			$("#lastServerLogUpdatedTimestamp", panelServerInfo._panel).text(dateFormat(now, "mediumTime"));
		}
		scroll = scroll || panelServerInfo.status.logScrollWithActivity();
		if(scroll)
		{
			elem.attr("scrollTop", elem.attr("scrollHeight"));
		}
	}
};

panelServerInfo.adminAction = function(action)
{
	var selectedIndex = $("#lstServers", panelServerInfo._panel).find("li.ui-widget-header").index();	if(!action || selectedIndex < 0) return;
	var cmdObj = {
		command: "adminAction",
		action : action,
		index : selectedIndex
	};
	adminPanel.data.serverRequest(
	cmdObj,
	function(data){
		var success = false;
		if(data)
		{
			var usersData = $.xml2json(data);
			if(usersData && usersData["response_status"] && usersData["response_status"]== "OK")
			{
				success = true;
			}
		}
		if(!success)
		{
			adminPanel.UI.growl("Failure", "Admin action " + action + " failed for index " + selectedIndex, true, true);
		}
		else
		{
			var msg = "Server Started";
			if(action == "stopServer")
				msg = "Server Stopped";
			else if(action == "restartServer")
				msg = "Server Restarted";
			adminPanel.UI.growl("Sucess", msg, false, 2000);
		}
	});
};

panelServerInfo.serverStatResetAction = function(action)
{
	var cmdObj = {
		command: "adminAction",
		action : action
	};
	adminPanel.data.serverRequest(
	cmdObj,
	function(data){
		var success = false;
		if(data)
		{
			var usersData = $.xml2json(data);
			if(usersData && usersData["response_status"] && usersData["response_status"]== "OK")
			{
				success = true;
			}
		}
		if(!success)
		{
			adminPanel.UI.growl("Failure", "Admin action " + action, true, true);
		}
		else
		{
			var msg = " Stats reset completed..";
			if(action == "allStats")
				msg = "All" + msg;
			else if(action == "loginStats")
				msg = "Login" + msg;
			else if(action == "transferStats")
				msg = "Transfer : Server Bytes (in, out)"  + msg;
			else if(action == "uploadDownloadStats")
				msg = "Upload/Download"  + msg;
			adminPanel.UI.growl("Sucess", msg, false, 2000);
		}
	});
};

panelServerInfo.bindEvents = function()
{
	$("#server_log_refresh", panelServerInfo._panel).unbind("click").click(function(){
		$("#server_log", panelServerInfo._panel).text("");
		adminPanel.data.dataRefreshCall();
		return false;
	});

	$("#serverInfoTab", panelServerInfo._panel).contextMenu({
		topPadding : 110,
		leftPadding : 20,
		menu: 'serverResetStatsContextMenu'
	}, function (action, el, pos, command) {
		jConfirm("Are you sure you want to : " + command + "?","Confirm", function(flag){
			if(flag)
			{
				panelServerInfo.serverStatResetAction(action);
			}
		});
		return false;
	}).click(function (evt) {
		evt.stopPropagation();
		evt.preventDefault();
		return false;
	});

	var val = [0];
	function drawGraph()
	{
		$('.sparklines', panelServerInfo._panel).sparkline(val, {
			width:"99%",
			height: "25%",
			type : "line",
			barColor : "#FED22F"
		});
		setTimeout(function(){
			val.push(Math.floor((Math.random()*100)+1));
			drawGraph();
		}, 500);
	}
	drawGraph();
};